/*
 * Copyright (c) 1997-2000 Centro de Informtica - UFPE
 */

package frames;

import java.awt.*;
import java.awt.event.*;
import frames.banco.*;
import frames.conta.*;

/**
 * Esta classe representa a janela principal do banco.
 */
public class FrameTeste extends Frame {

    // Barra de menu principal
    private MenuBar mnuBarra = new MenuBar();
    // Opo Cadastrar
    private Menu mnuCadastrar = new Menu();
    // Item Conta da opo Cadastrar
    private MenuItem mnuItemConta = new MenuItem();
    // Opo Sair
    private Menu mnuSair = new Menu();
    // Item Sair da opo Sair
    private MenuItem mnuItemSair = new MenuItem();
    // Rotulo Creditar
    private Label ldlCreditar = new Label();
    // Campo de texto usado para creditar
    private TextField textFieldCreditar = new TextField();
    // Boto Creditar
    private Button btnCreditar = new Button();
    // Rotulo Debitar
    private Label lblDebitar = new Label();
    // Campo de texto usado para debitar
    private TextField textFieldDebitar = new TextField();
    // Boto Debitar
    private Button btnDebitar = new Button();
    // Rotulo Saldo
    private Label lblSaldo = new Label();
    // Campo que mostra o saldo corrente
    private TextField textFieldSaldo = new TextField();
    // Rotulo do numero da conta
    private Label lblNumeroConta = new Label();
    // Campo de texto para consulta pelo nmero da conta
    private TextField textFieldNumero = new TextField();
    // Boto para consultar
    private Button btnConsultar = new Button();
    // Rtulo da conta atual
    private Label lblContaAtual = new Label();
    // Campo que mostra o nmero da conta atual
    private TextField textFieldContaAtual = new TextField();

    // Frame de cadastro de conta
    private FrameCadastro frmCadastro;
    // classe fachada do sistema
    private Banco banco;
    // conta sendo consultada
    private Conta contaAtual = null;

    // Panel que contm o Label, o TextField e o Button NumeroConta/Consultar.
    private Panel pnl = new Panel();
    // Panel que contm o Label, o TextField e o Button Creditar.
    private Panel pnl2 = new Panel();
    // Panel que contm o Label, o TextField e o Button Debitar.
    private Panel pnl3 = new Panel();
    // Panel que contm o Label, o TextField e o Button ContaAtual.
    private Panel pnl4 = new Panel();
    // Panel que contm o Label, o TextField e o Button Saldo.
    private Panel pnl5 = new Panel();
    // Layout que organiza os botes, text fields, etc. na tela.
    private FlowLayout flowLayout = new FlowLayout();

    /**
     * Construtor da classe. Inicializa a janela principal.
     */
    public FrameTeste() {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try  {
            jbInit();
        }
        catch (Exception excecao) {
            excecao.printStackTrace();
        }
    }

    // Mtodo auxiliar do construtor.
    private void jbInit() throws Exception {

        this.setLayout(flowLayout);
        this.setBackground(Color.lightGray);
        this.setSize(new Dimension(302, 221));
        this.setTitle("Banco Java");
        this.setMenuBar(mnuBarra);
        mnuCadastrar.setLabel("Cadastrar");
        mnuItemConta.setLabel("Conta");
        mnuSair.setLabel("Sair");
        mnuItemSair.setLabel("Sair");
        mnuItemSair.addActionListener(new GUIContaMnuItemSairActionAdapter(this));

        lblSaldo.setText("Saldo:");
        lblContaAtual.setFont(new Font("Dialog", 0, 12));
        textFieldContaAtual.setForeground(Color.red);
        textFieldSaldo.setForeground(Color.red);
        textFieldNumero.setBackground(Color.white);
        textFieldCreditar.setBackground(Color.white);
        textFieldDebitar.setBackground(Color.white);
        mnuBarra.add(mnuCadastrar);
        mnuBarra.add(mnuSair);
        mnuCadastrar.add(mnuItemConta);
        this.add(pnl, null);
        pnl.add(lblNumeroConta, null);
        pnl.add(textFieldNumero, null);
        pnl.add(btnConsultar, null);
        this.add(pnl2, null);
        pnl2.add(ldlCreditar, null);
        pnl2.add(textFieldCreditar, null);
        pnl2.add(btnCreditar, null);
        this.add(pnl3, null);
        pnl3.add(lblDebitar, null);
        pnl3.add(textFieldDebitar, null);
        pnl3.add(btnDebitar, null);
        this.add(pnl4, null);
        pnl4.add(lblContaAtual, null);
        pnl4.add(textFieldContaAtual, null);
        this.add(pnl5, null);
        pnl5.add(lblSaldo, null);
        pnl5.add(textFieldSaldo, null);
        mnuSair.add(mnuItemSair);
        btnDebitar.setLabel("Debitar");
        btnDebitar.addActionListener(new FrmTesteBtnDebitarActionAdapter(this));
        btnCreditar.setLabel("Creditar");
        btnCreditar.addActionListener(new FrmTesteBtnCreditarActionAdapter(this));
        lblContaAtual.setText("Conta Atual:");
        btnConsultar.setLabel("Consultar");
        btnConsultar.addActionListener(new FrmTesteBtnConsultarActionAdapter(this));
        lblNumeroConta.setText("Numero da Conta:");
        lblDebitar.setText("Valor do Debito:");
        ldlCreditar.setText("Valor do Credito:");
        mnuItemConta.addActionListener(new FrmTesteMnuItemContaActionAdapter(this));

        banco = new Banco();
        frmCadastro = new FrameCadastro(banco); /* iniciado o frmCadastro */
                                      /* e passando a classe fachada para ele */
        textFieldDebitar.setColumns(10);
        textFieldCreditar.setColumns(10);
        textFieldNumero.setColumns(10);
        textFieldSaldo.setColumns(10);
        textFieldContaAtual.setColumns(10);
        textFieldSaldo.setEditable(false);
        textFieldContaAtual.setEditable(false);
        frmCadastro.setLocation(30,150);
    }

    // Limpa os campos de texto do frame.
    private void limpaTela() {
        contaAtual = null;
        textFieldNumero.setText("");
        textFieldContaAtual.setText("");
        textFieldSaldo.setText("");
    }

    /**
     * Item Conta do menu.
     *
     * @param e Evento ocorrido.
     */
    public void mnuItemContaActionPerformed(ActionEvent e) {
        limpaTela();
        frmCadastro.setVisible(true);
    }

    /**
     * ActionPerformed do subitem "Sair" do item "Sair" do menu.
     *
     * @param e Evento ocorrido.
     */
    public void mnuItemSairActionPerformed(ActionEvent e) {
        System.exit(0);
    }

    /**
     * Consulta uma conta.
     *
     * @param e Evento ocorrido.
     */
    public void btnConsultarActionPerformed(ActionEvent e) {
        try {
            contaAtual = banco.procurar(textFieldNumero.getText());
            textFieldNumero.setText("");
            textFieldContaAtual.setText(contaAtual.getNumero());
            textFieldSaldo.setText(String.valueOf(contaAtual.getSaldo()));
        }
        catch (ContaNaoEncontradaException excecao) { // conta nao encontrada
            DialogMensagem dgMsg = new DialogMensagem(this, "Banco Java",
                                                      excecao.getMessage());
            dgMsg.setVisible(true);
            textFieldNumero.requestFocus();
        }
    }

    /**
     * Cradita na conta atual.
     *
     * @param e Evento ocorrido.
     */
    public void btnCreditarActionPerformed(ActionEvent e) {
        try {
            banco.creditar(contaAtual.getNumero(),
                           (Double.valueOf(textFieldCreditar.getText()))
                                           .doubleValue());
            textFieldSaldo.setText("");
            textFieldSaldo.setText(String.valueOf(contaAtual.getSaldo()));
        }
        catch (Exception excecao) {  // algum problema aconteceu
            DialogMensagem dgMsg = new DialogMensagem(this, "Banco Java",
                                    "Valor invalido ou conta nao selecionada");
            dgMsg.setVisible(true);
        }
        finally {
            textFieldCreditar.setText("");
        }
    }

    /**
     * Debita na conta atual.
     *
     * @param e Evento ocorrido.
     */
    public void btnDebitarActionPerformed(ActionEvent e) {
        try {
            banco.debitar(contaAtual.getNumero(),
                          (Double.valueOf(textFieldDebitar.getText()))
                                          .doubleValue());
            textFieldSaldo.setText("");
            textFieldSaldo.setText(String.valueOf(contaAtual.getSaldo()));
        }
        catch (Exception excecao) {  // ocorreu algum problema
            DialogMensagem dgMsg = new DialogMensagem(this, "Banco Java",
                                "Valor invalido ou conta nao selecionada");
            dgMsg.setVisible(true);
        }
        finally {
            textFieldDebitar.setText("");
        }
    }

    /**
     * Sobreposicao do metodo para fechar a janela e sair do programa. Chamado
     * quando se clica no "X" do canto superior direito da tela.
     *
     * @param e Evento ocorrido.
     */
    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            System.exit(0);
        }
    }

    /**
     * Mtodo de testes do sistema. Cria o Frame principal e mostra na tela.
     */
    public static void main(String[] args) {

        FrameTeste frmTeste = new FrameTeste();
        frmTeste.setSize(400,300);
        frmTeste.setLocation(50,50);
        frmTeste.show();
    }

}


/**
 * Listener criado pelo JBuilder.
 *  o responsavel pela execuo a opo "Sair" do menu.
 */
class GUIContaMnuItemSairActionAdapter implements java.awt.event.ActionListener {

    // Frame principal.
    private FrameTeste adaptee;

    /**
     * Construtor da classe.
     *
     * @param adaptee Frame principal, onde a ao ter efeito.
     */
    public GUIContaMnuItemSairActionAdapter(FrameTeste adaptee) {
        this.adaptee = adaptee;
    }

    /**
     * Mtodo chamado quando o boto  pressionado.
     *
     * @param e Evento ocorrido.
     */
    public void actionPerformed(ActionEvent e) {
        adaptee.mnuItemSairActionPerformed(e);
    }

}


/**
 * Listener criado pelo JBuilder.
 *  o responsavel pela execuo a opo "Cadastrar" do menu Conta.
 */
class FrmTesteMnuItemContaActionAdapter
        implements java.awt.event.ActionListener {

    // Frame principal.
    private FrameTeste adaptee;

    /**
     * Construtor da classe.
     *
     * @param adaptee Frame principal, onde a ao ter efeito.
     */
    public FrmTesteMnuItemContaActionAdapter(FrameTeste adaptee) {
        this.adaptee = adaptee;
    }

    /**
     * Mtodo chamado quando o boto  pressionado.
     *
     * @param e Evento ocorrido.
     */
    public void actionPerformed(ActionEvent e) {
        adaptee.mnuItemContaActionPerformed(e);
    }

}


/**
 * Listener criado pelo JBuilder.
 *  o responsavel pelo boto "Consultar".
 */
class FrmTesteBtnConsultarActionAdapter
        implements java.awt.event.ActionListener {

    // Frame principal.
    private FrameTeste adaptee;

    /**
     * Construtor da classe.
     *
     * @param adaptee Frame principal, onde a ao ter efeito.
     */
    public FrmTesteBtnConsultarActionAdapter(FrameTeste adaptee) {
        this.adaptee = adaptee;
    }

    /**
     * Mtodo chamado quando o boto  pressionado.
     *
     * @param e Evento ocorrido.
     */
    public void actionPerformed(ActionEvent e) {
        adaptee.btnConsultarActionPerformed(e);
    }

}


/**
 * Listener criado pelo JBuilder.
 *  o responsavel pelo boto "Creditar".
 */
class FrmTesteBtnCreditarActionAdapter
        implements java.awt.event.ActionListener {

    // Frame principal.
    private FrameTeste adaptee;

    /**
     * Construtor da classe.
     *
     * @param adaptee Frame principal, onde a ao ter efeito.
     */
    public FrmTesteBtnCreditarActionAdapter(FrameTeste adaptee) {
        this.adaptee = adaptee;
    }

    /**
     * Mtodo chamado quando o boto  pressionado.
     *
     * @param e Evento ocorrido.
     */
    public void actionPerformed(ActionEvent e) {
        adaptee.btnCreditarActionPerformed(e);
    }

}


/**
 * Listener criado pelo JBuilder.
 *  o responsavel pelo boto "Debitar".
 */
class FrmTesteBtnDebitarActionAdapter implements java.awt.event.ActionListener {

    // Frame principal.
    private FrameTeste adaptee;

    /**
     * Construtor da classe.
     *
     * @param adaptee Frame principal, onde a ao ter efeito.
     */
    public FrmTesteBtnDebitarActionAdapter(FrameTeste adaptee) {
        this.adaptee = adaptee;
    }

    /**
     * Mtodo chamado quando o boto  pressionado.
     *
     * @param e Evento ocorrido.
     */
    public void actionPerformed(ActionEvent e) {
        adaptee.btnDebitarActionPerformed(e);
    }

}