/*
 * Copyright (c) 1997-2000 Centro de Informtica - UFPE
 */

package frames.conta;

/**
 * Exceo jogada caso se tente cadastrar/inserir uma conta j existente no
 * banco.
 */
public class ContaJaExisteException extends Exception {

    // Nmero da conta existente.
    private String numero;

    /**
     * Contrutor da classe.
     *
     * @param numero Nmero da conta existente.
     */
    public ContaJaExisteException(String numero) {
        super ("Conta j existente!");
        this.numero = numero;
    }

    /**
     * Retorna o nmero da conta existente.
     *
     * @return Nmero da conta existente.
     */
    public String getNumero() {
        return numero;
    }

} 