/*
 * Copyright (c) 1997-2000 Centro de Informtica - UFPE
 */

package frames.conta;

/**
 * Exceo jogada caso a conta no seja encontrada no banco.
 */
public class ContaNaoEncontradaException extends Exception {

    // Nmero da conta no encontrada.
    private String numero;

    /**
     * Construtor da classe.
     *
     * @param numero Nmero da conta no encontrada.
     */
    public ContaNaoEncontradaException(String numero) {
        super ("Conta no encontrada!");
        this.numero = numero;
    }

    /**
     * Retorna o nmero da conta no encontrada no banco.
     *
     * @return O nmero da conta no encontrada no banco.
     */
    public String getNumero() {
        return numero;
    }

}