/*
 * Copyright (c) 1997-2000 Centro de Informtica - UFPE
 */

package frames.conta;

/**
 * Exceo jogada caso o saldo no seja suficiente para se completar uma
 * operao de dbito ou transferncia.
 */
public class SaldoInsuficienteException extends Exception {

    // Saldo no momento em que ocorreu a exceo.
    private double saldo;

    // Nmero da conta onde ocorreu a exceo.
    private String	numero;

    /**
     * Construtor da classe.
     *
     * @param saldo Saldo no momento em que ocorreu a exceo.
     * @param numero Nmero da conta onde ocorreu a exceo.
     */
    public SaldoInsuficienteException (double saldo, String numero) {
        super ("Saldo Insuficiente!");
        this.saldo = saldo;
        this.numero = numero;
    }

    /**
     * Retorna o saldo da conta onde ocorreu a exceo.
     *
     * @return Saldo no momento em que ocorreu a exceo.
     */
    public double getSaldo() {
        return saldo;
    }

    /**
     * Retorna o nmero da conta onde ocorreu a exceo.
     *
     * @return Nmero da conta onde ocorreu a exceo.
     */
    public String getNumero() {
        return numero;
    }

}